namespace IrrlichtNetSwig
{
    public partial class arraySMD3MeshBuffer
    {
        public SMD3MeshBuffer this[uint index]
        {
            get
            {
                if (index < 0 || size() < index)
                {
                    throw new System.IndexOutOfRangeException();
                }
                return getValue(index);
            }
            set
            {
                if (index < 0 || size() < index)
                {
                    throw new System.IndexOutOfRangeException();
                }
                setValue(index, value);
            }
        }
        public void set_pointer(SMD3MeshBuffer[] pointer)
        {
            set_pointer((arraySMD3MeshBuffer)pointer, (uint)pointer.Length);
        }
        public static implicit operator arraySMD3MeshBuffer(SMD3MeshBuffer[] other)
        {
            var arr = new arraySMD3MeshBuffer((uint)other.Length);
            for (uint i = 0; i < other.Length; i++)
            {
                arr.push_back(other[i]);
            }
            return arr;
        }
        public SMD3MeshBuffer[] ToArray()
        {
            var arr = new SMD3MeshBuffer[size()];
            for (uint i = 0; i < size(); i++)
            {
                arr[i] = this.getValue(i);
            }
            return arr;
        }
    }
}